#
# Name: hp_qla2x00.spec
# Copyright: (c)2004 Hewlett-Packard Company
#
# Description: spec file for hp_qla2x00 RPM

Name: hp_qla2x00 
Version: 7.07.03p4
Release: 9
Summary: HP QLA HBA Driver 
Source: hp_qla2x00.tar.gz
Vendor: Hewlett-Packard
Copyright: proprietary
Group: System/Kernel 
BuildRoot: %{_builddir}/hp_qla2x00

%undefine __check_files

%description
Loads the HP supported QLogic HBA driver.  

%prep

# use this section ot untar the source file

rm -fr $RPM_BUILD_DIR/hp_qla2x00
gunzip $RPM_SOURCE_DIR/hp_qla2x00.tar.gz
tar xvf $RPM_SOURCE_DIR/hp_qla2x00.tar

%build

# Get the kernel version that the binary RPM produced will install on
# either through the HPQLA2X00KVERSION environmental variable or the
# uname -r command

if [ "$HPQLA2X00KVERSION" != "" ]
then
 KERNELVERSION=$HPQLA2X00KVERSION

 # check to make sure this kernel is installed on this machine

 if test ! -d /lib/modules/${KERNELVERSION}
 then
	echo ""
	echo "/lib/modules/${KERNELVERSION} does not exist!"
	echo ""
	exit 1
 fi
else
 KERNELVERSION=`uname -r`
fi

# get the directory name of the kernel sources
# from the kernel version given

if test -f /etc/SuSE-release
then
 KERNELSRCDIR=linux-`echo $KERNELVERSION | awk 'BEGIN {FS="-"} {print $1"-"$2}'`
elif test -f /etc/redhat-release
then
 if [ "`cat /etc/redhat-release | grep 2.1`" != "" ]
 then
	### RHAS 2.1 ###
	KERNELSRCDIR="linux-`echo $KERNELVERSION | awk 'BEGIN {FS="-"} {print $1}'`-`echo $KERNELVERSION | awk 'BEGIN {FS="-"} {print $2}' | cut -c 1-4`"
 elif [ "`cat /etc/redhat-release | grep "release 3"`" != "" ]
 then
	### RHEL 3 ###
	# Because of some of the odd naming convetions with RHEL 3 kernels, the kernel name has to
	# be broken about, any kernel type stripped off the second part (such as "smp") and then the
	# name has to be reassembled
 	PART1=`uname -r | awk 'BEGIN {FS="-"} {print $1}'`
	PART2=`uname -r | awk 'BEGIN {FS="-"} {print $2}' | awk 'BEGIN {FS="."} {if ($3 == "") {$2 = substr($2, 1, 2); print $1"."$2} else {$4 = substr($4, 1, 2); print $1"."$2"."$3"."$4}}'`
	KERNELSRCDIR=linux-"${PART1}-${PART2}"
 fi
else
	echo ""
	echo "Unsupported distribution"
	echo ""
	exit 1
fi

# execute condition kernel script

$RPM_BUILD_ROOT/condition_kernel -m $KERNELVERSION -s $KERNELSRCDIR

# determine what OSVER flag should be

if [ -d /usr/src/linux-include ]
then
 OSVER=${KERNELSRCDIR}-include/`echo $KERNELVERSION | awk 'BEGIN {FS="-"} {if ($4 == "") print $3; else print $3"-"$4}'`
elif [ -d /usr/src/linux-2.4 ]
then
 OSVER=$KERNELSRCDIR
else
 OSVER=linux
fi

# determine SMP flag

if [ "`cat /proc/version | grep SMP`" = "" ]
then
 SMP=0
else
 SMP=1
fi

# build driver

cd $RPM_BUILD_ROOT
make clean
make OSVER=$OSVER SMP=$SMP all

%install

OPTDIR=opt/hp/hp_qla2x00
LIBDIR=usr/lib

# copy opt directory files

mkdir -p $RPM_BUILD_ROOT/$OPTDIR
cp $RPM_BUILD_ROOT/qla2200.o $RPM_BUILD_ROOT/$OPTDIR/qla2200.o
cp $RPM_BUILD_ROOT/qla2300.o $RPM_BUILD_ROOT/$OPTDIR/qla2300.o
cp $RPM_BUILD_ROOT/qla2300_conf.o $RPM_BUILD_ROOT/$OPTDIR/qla2300_conf.o
cp $RPM_BUILD_ROOT/qla_opts $RPM_BUILD_ROOT/$OPTDIR/qla_opts
cp $RPM_BUILD_ROOT/set_parm $RPM_BUILD_ROOT/$OPTDIR/set_parm
cp $RPM_BUILD_ROOT/edit_conf $RPM_BUILD_ROOT/$OPTDIR/edit_conf
cp $RPM_BUILD_ROOT/make_initrd $RPM_BUILD_ROOT/$OPTDIR/make_initrd
cp $RPM_BUILD_ROOT/README $RPM_BUILD_ROOT/$OPTDIR/README
cp $RPM_BUILD_ROOT/readme.libqlsdm $RPM_BUILD_ROOT/$OPTDIR/readme.libqlsdm
cp $RPM_BUILD_ROOT/set_parm2 $RPM_BUILD_ROOT/$OPTDIR/set_parm2

# copy /etc files

mkdir -p $RPM_BUILD_ROOT/etc

if [ "$HPQLA2X00KVERSION" = "" ]
then
 echo "`uname -r`" > $RPM_BUILD_ROOT/etc/.hp_pkinstall
else
 echo "$HPQLA2X00KVERSION" > $RPM_BUILD_ROOT/etc/.hp_pkinstall
fi 

# copy qlsdm library based on architecture

mkdir -p $RPM_BUILD_ROOT/$LIBDIR
if [ "`uname -m`" = "i386" ] || [ "`uname -m`" = "i486" ] || [ "`uname -m`" = "i586" ] || [ "`uname -m`" = "i686" ] || [ "`uname -m`" = "x86_64" ]
then
 cp $RPM_BUILD_ROOT/libqlsdm-ia32.so $RPM_BUILD_ROOT/$LIBDIR/libqlsdm.so
#elif [ "`uname -m`" = "x86_64" ]
#then
# cp $RPM_BUILD_ROOT/libqlsdm-x86_64.so $RPM_BUILD_ROOT/$LIBDIR/libqlsdm.so
elif [ "`uname -m`" = "ia64" ]
then
 cp $RPM_BUILD_ROOT/libqlsdm-ia64.so $RPM_BUILD_ROOT/$LIBDIR/libqlsdm.so
fi

%files

%attr (644,root,root)	/opt/hp/hp_qla2x00/qla2200.o
%attr (644,root,root)	/opt/hp/hp_qla2x00/qla2300.o
%attr (644,root,root)	/opt/hp/hp_qla2x00/qla2300_conf.o
%attr (700,root,root)	/opt/hp/hp_qla2x00/qla_opts
%attr (744,root,root)	/opt/hp/hp_qla2x00/edit_conf
%attr (744,root,root)	/opt/hp/hp_qla2x00/make_initrd
%attr (744,root,root)	/opt/hp/hp_qla2x00/set_parm
%attr (744,root,root)	/opt/hp/hp_qla2x00/set_parm2
%attr (444,root,root)	/opt/hp/hp_qla2x00/README
%attr (444,root,root)	/opt/hp/hp_qla2x00/readme.libqlsdm
%attr (444,root,root)	/etc/.hp_pkinstall
%attr (644,root,root)	/usr/lib/libqlsdm.so


%clean

rm -fr $RPM_BUILD_DIR/hp_qla2x00
gzip $RPM_SOURCE_DIR/hp_qla2x00.tar

%changelog
* Wed Apr 05 2006 Chad Dupuis

- Added 7.07.03p4 QLogic adapter driver

* Thu Mar 16 2006 Chad Dupuis

- Added 7.07.03p3 QLogic adapter driver
- Copy x86 version of libqlsdm.so to x86_64 systems

* Tue Jan 31 2006 Chad Dupuis

- Fixed missing bracket typo in set_parm

* Mon Jan 23 2006 Chad Dupuis

- Added 7.07.03p1 QLogic adapter driver
- Changed ql2xautorestore to 0x80

* Mon Dec 19 2005 Chad Dupuis

- Added 7.07.03 QLogic adapter driver
- Set ql2xautorestore to 0x0
- Added libqlsdm.so version 2.01.01 beta 3

* Wed Nov 16 2005 Chad Dupuis

- Set ql2xautorestore parameter in /etc/modules.conf

* Tue Nov 15 2005 Chad Dupuis

- Added 7.07.03b10 QLogic adapter driver

* Wed Nov 02 2005 Chad Dupuis

- Added 7.07.03b7 QLogic adapter driver

* Tue Nov 01 2005 Chad Dupuis

- Added 7.07.03b6 QLogic adapter driver
- Added SDM library version 2.01.01 beta 2

* Fri Sep 16 2005 Chad Dupuis

- Added version 7.05.00p8 of the QLogic adapter driver

* Thu Sep 15 2005 Chad Dupuis

- Added version 7.05.00p7 of the QLogic adatper driver
- Fixed device binding issue when MSA1000 LUNs are on
  the second HBA

* Mon Aug 15 2005 Chad Dupuis

- Added 7.05.00p5 version of the QLogic adapter driver
- Fixed issue with XP LUNS not showing up after boot
- Fixed bus reset issue with XP
- Added ioctl fixes for Rubah libraries
- Added support for Mendicino software
- Make a "*" in /proc always be displayed in front
  of a controller LUN fro an EVA or MSA
- Added strings in the failover table for HSV101,
  HSV111, and HSV200
- Added 2.01.01 beta 1 libqlsdm.so library
- Added x86_64 version of the libqlsdm.so library

* Fri Jul 29 2005 Chad Dupuis

- Added consolodated patch 7.05.00p3 to base 7.05.00
  driver sources

* Mon Jul 25 2005 Chad Dupuis

- Make binary RPM produced from this source RPM only install
  on a specific kernel

* Wed May 11 2005 Chad Dupuis

- Reverted back to original 7.05.00 driver

* Mon May 02 2005 Chad Dupuis

- Added code to upgrade /etc/hp_qla2x00.conf with new settings
  if necessary
- Added "a" to the QLogic version file to designate the patched
  driver from the original
- Added patch to 7.05.00 for EVA XL
- Added new driver parameters: ql2xlbType and ql2xexcludemodel which
  include edits to edit_conf and set_parm

* Wed Mar 23 2005 Chad Dupuis

- Changed libqlsdm library back to 2.01 beta 14 (from beta 17)

* Mon Mar 20 2005 Chad Dupuis

- Added 7.05.00 driver sources
- Added new make_initrd script to recognize
  HP-* initrds
- Added new make_initrd script to recognize
  HP-initrd-* initrds

* Wed Feb 23 2005 Chad Dupuis

- Added 7.05.00b3 driver sources

* Mon Jan 10 2005 Chad Dupuis

- Added 7.04.00b6 driver sources
- Save original driver files as .orig instead
  of .old; don't copy current object file to .old
  on every install

* Wed Sep 29 2004 Chad Dupuis 

- Added EVA failover patch

* Thu Sep 23 2004 Chad Dupuis

- Added more fixes for parsing RHAS 2.1 test or hotfix
  kernels

* Tue Sep 08 2004 Chad Dupuis 

- Parse hotfix or TEST kernels in Red Hat AS 2.1
  correctly
- If a machine is a x86_64 architecture but is
  running an Intel 32e processor, change ARCH to
  ia32e

* Fri Aug 27 2004 Chad Dupuis 

- Added fix to condition_kernel that parses RHEL3
  kernel name with Secure Path fix correctly

* Fri Aug 20 2004 Chad Dupuis 

- Removed fixes for RHEL 3, U3 naming problem
- Exit from condition_kernel if .config file doesn't exist

* Thu Aug 19 2004 Chad Dupuis 

- Move qla2200_conf.o and qla2300_conf.o files in the ...addon/qla2200
  directory on RHEL 3 if they exist

* Tue Aug 17 2004 Chad Dupuis 

- Added new make_initrd
- Added fix to condition_kernel to parse RHEL 3, U3
  kernel names correctly

* Thu Aug 12 2004 Chad Dupuis 

- Added code to determine if currently loaded driver
  is in failover or nonfailover mode
- Added 7.01.01 driver sources

* Fri Jul 23 2004 Chad Dupuis 

- Added 7.00.04b5 driver sources

* Mon Jul 19 2004 Chad Dupuis 

- Added 7.00.04b4 driver source

* Thu Jun 21 2004 Chad Dupuis 

- Fixed make_initrd to only make a new initrd for
  the running kernel on SUSE distributions

* Thu Jun 17 2004 Chad Dupuis 

- Updated condition_kernel to work correctly on AMD Opeteron
  servers with the OS running in a pure 32-bit mode

* Mon Jun 14 2004 Chad Dupuis 

- Added support for x86_64 architecture
- Added preinstall check for 2.4 kernel

%pre

# make sure we are installing on a 2.4 kernel

KERNVER=`uname -r | cut -c 1-3`

if [ "$KERNVER" != "2.4" ]
then
 echo ""
 echo "This machine is not running a 2.4 kernel!"
 echo ""
 exit 1
fi

%post

# See what kernel version this RPM was build for.  If it does not exist, 
# exit and tell user to uninstall RPM

if [ "`cat /etc/.hp_pkinstall`" != "" ]
then
 KERNELVERSION=`cat /etc/.hp_pkinstall`
 
 # test if kernel directory exists in /lib/modules

 if test ! -d /lib/modules/$KERNELVERSION
 then
	echo "/lib/modules/$KERNELVERSION does not exist."
	echo "You should uninstall this rpm using the \"rpm -e --noscripts hp_qla2x00\""
	echo "command"
	exit 1
 fi
 echo "Using kernel version $KERNELVERSION from /etc/.hp_pkinstall"
else
 KERNELVERSION=`uname -r`
 echo "Using kernel version $KERNELVERSION from uname -r"
fi
SRCDIR=/opt/hp/hp_qla2x00

# create hp_qla2x00.conf if needed

ls /etc/hp_qla2x00.conf 1>/dev/null 2>/dev/null

if [ $? -ne 0 ]
then
 # determine if a driver already loaded in memory is in failover mode
 # or single path mode.  If no driver is loade default to single path

 if test -d /proc/scsi/qla2300
 then
        FOMODE=`more /proc/scsi/qla2300/* | grep "Driver version" | grep fo`

        # use set_parm2 to write out the correct settings

        if [ "$FOMODE" = "" ]
        then
                echo "Loaded driver is in nonfailover mode"
                $SRCDIR/set_parm2 -s
        else
                echo "Loaded driver is in failover mode"
                $SRCDIR/set_parm2 -x
        fi
 else
        # no driver loaded, so default to failover mode

        echo "No driver loaded, using failover mode"
        $SRCDIR/set_parm2 -x
 fi
else
 echo "/etc/hp_qla2x00.conf already exists.  Using parameters in the current file."

 # check to see if ql2xlbType needs to be put in

 if [ "`cat /etc/hp_qla2x00.conf 2>/dev/null | grep load_balancing`" = "" ]
 then
        # figure out if driver is in failover or non-failover mode

        CONFFILE_FOMODE=`cat /etc/hp_qla2x00.conf 2>/dev/null | grep failover | awk '{print $3}'`

        if [ "$CONFFILE_FOMODE" = "1" ]
        then
                echo "load_balancing = 1" >> /etc/hp_qla2x00.conf
        else
                echo "load_balancing = 0" >> /etc/hp_qla2x00.conf
        fi
 fi

 # check to see if ql2xexcludemodel needs to be put in

 if [ "`cat /etc/hp_qla2x00.conf 2>/dev/null | grep excludemodel`" = "" ]
 then
        # test to see if Secure Path directory exists

        if test -d /etc/CPQswsp
        then
                echo "excludemodel = 0x06" >> /etc/hp_qla2x00.conf
        else
                echo "excludemodel = 0x0" >> /etc/hp_qla2x00.conf
        fi
 fi

 # check to see if ql2xautorestore needs to be put in

 if [ "`cat /etc/hp_qla2x00.conf 2>/dev/null | grep auto_restore`" = "" ]
 then
        # figure out if driver is in failover or non-failover mode

        CONFFILE_FOMODE=`cat /etc/hp_qla2x00.conf 2>/dev/null | grep failover | awk '{print $3}'`

        if [ "$CONFFILE_FOMODE" = "1" ]
        then
                echo "auto_restore = 0x80" >> /etc/hp_qla2x00.conf
        else
                echo "auto_restore = 0x0" >> /etc/hp_qla2x00.conf
        fi
 fi
fi

# Modify /etc/hba.conf

if [ -f "/etc/hba.conf" ]
then
 # file exists, see if we need to make the edit

 if [ `grep -c qla2x00 /etc/hba.conf` -eq 0 ]
 then
        echo "Modifying /etc/hba.conf"
        echo "qla2x00   /usr/lib/libqlsdm.so" >> /etc/hba.conf
 fi
else
 # file does not exist, create it

 echo "Modifying /etc/hba.conf"
 echo "qla2x00  /usr/lib/libqlsdm.so" >> /etc/hba.conf
fi

# determine correct module directory

if [ -d /lib/modules/${KERNELVERSION}/kernel/drivers/addon/qla2xxx ]
then
 MODDIR=/lib/modules/${KERNELVERSION}/kernel/drivers/addon/qla2xxx
elif [ -d /lib/modules/${KERNELVERSION}/kernel/drivers/addon/qla2200 ]
then
 MODDIR=/lib/modules/${KERNELVERSION}/kernel/drivers/addon/qla2200
else
 MODDIR=/lib/modules/${KERNELVERSION}/kernel/drivers/scsi
fi
SCSIDIR=/lib/modules/${KERNELVERSION}/kernel/drivers/scsi

# save qla2300, qla2300_conf.o

echo "Saving old modules"

if [ "`uname -m`" != "ia64" ] && [ "`uname -m`" != "x86_64" ]
then
 if test -f $MODDIR/qla2200.o  && test ! -f $MODDIR/qla2200.orig
 then
 	mv $MODDIR/qla2200.o $MODDIR/qla2200.orig
 fi

 if test -f /lib/modules/${KERNELVERSION}/kernel/drivers/addon/qla2200/qla2200_conf.o && test ! -f /lib/modules/${KERNELVERSION}/kernel/drivers/addon/qla2200/qla2200_conf.orig
 then
        mv -f /lib/modules/${KERNELVERSION}/kernel/drivers/addon/qla2200/qla2200_conf.o /lib/modules/${KERNELVERSION}/kernel/
drivers/addon/qla2200/qla2200_conf.orig
 fi
fi

if test -f $MODDIR/qla2300.o && test ! -f $MODDIR/qla2300.orig
then
 mv $MODDIR/qla2300.o $MODDIR/qla2300.orig
fi

if test -f $SCSIDIR/qla2300_conf.o && test ! -f $SCSIDIR/qla2300_conf.orig
then
 mv $SCSIDIR/qla2300_conf.o $SCSIDIR/qla2300_conf.orig
fi

if test -f /lib/modules/${KERNELVERSION}/kernel/drivers/addon/qla2200/qla2300_conf.o && test ! -f /lib/modules/${KERNELVERSION}/kernel/drivers/addon/qla2200/qla2300_conf.orig
then
 mv -f /lib/modules/${KERNELVERSION}/kernel/drivers/addon/qla2200/qla2300_conf.o /lib/modules/${KERNELVERSION}/kernel/drivers/addon/qla2200/qla2300_conf.orig
fi

# copy qla2300, qla2300_conf.o

echo "Copying new modules from $SRCDIR"

if [ "`uname -m`" != "ia64" ] && [ "`uname -m`" != "x86_64" ]
then
 cp ${SRCDIR}/qla2200.o ${MODDIR}/qla2200.o
fi

cp ${SRCDIR}/qla2300.o ${MODDIR}/qla2300.o
cp ${SRCDIR}/qla2300_conf.o ${SCSIDIR}/qla2300_conf.o

# run depmod

echo "Running depmod -a"
depmod -a

# run qla_opts if need be

if [ -a /etc/qla2300.conf ]
then
 echo "Updating qla2300_conf with configuration data from /etc/qla2300.conf"
 ${SRCDIR}/qla_opts -w qla2300_conf
fi

# edit configuration files

$SRCDIR/edit_conf

# make new initrd

$SRCDIR/make_initrd

echo ""
echo "Utility files are located in $SRCDIR"

%preun

if test -f /etc/.hp_pkinstall
then
 cp /etc/.hp_pkinstall /tmp/.hp_pkinstall
fi

%postun

ls /etc/.hp_pkinstall 1>/dev/null 2>/dev/null

if [ $? -ne 0 ]
then
 ### we are removing the package, so uninstall everything ###

 if [ "`cat /tmp/.hp_pkinstall`" != "" ]
 then
 	KERNELVERSION=`cat /tmp/.hp_pkinstall`
 	echo "Using kernel version $KERNELVERSION from /tmp/.hp_pkinstall"
 else
 	KERNELVERSION=`uname -r`
 	echo "Using kernel version $KERNELVERSION from uname -r"
 fi

 SRCDIR="/opt/hp/hp_qla2x00"

 # remove /etc/hp_qla2x00.conf

 echo "Removing /etc/hp_qla2x00.conf"
 rm -f /etc/hp_qla2x00.conf

 # remove reference from /etc/hba.conf to qla2x00

 echo "Removing reference to qla2x00 from /etc/hba.conf"
 cat /etc/hba.conf | grep -v qla2x00 > /tmp/hba.conf
 mv /etc/hba.conf /etc/hba.conf.old
 mv /tmp/hba.conf /etc/hba.conf
 chmod 644 /etc/hba.conf
 chown root:root /etc/hba.conf

 # set module directories

 if [ -d /lib/modules/${KERNELVERSION}/kernel/drivers/addon/qla2xxx ]
 then
 	MODDIR=/lib/modules/${KERNELVERSION}/kernel/drivers/addon/qla2xxx
 elif [ -d /lib/modules/${KERNELVERSION}/kernel/drivers/addon/qla2200 ]
 then
 	MODDIR=/lib/modules/${KERNELVERSION}/kernel/drivers/addon/qla2200
 else
 	MODDIR=/lib/modules/${KERNELVERSION}/kernel/drivers/scsi
 fi
 SCSIDIR=/lib/modules/${KERNELVERSION}/kernel/drivers/scsi

 # remove current modules

 echo "Removing (qla2200.o) qla2300.o and qla2300_conf.o"

 if [ "`uname -m`" != "ia64" ] && [ "`uname -m`" != "x86_64" ]
 then
 	rm -f ${MODDIR}/qla2200.o
 fi

 rm -f ${MODDIR}/qla2300.o
 rm -f ${MODDIR}/qla2300_conf.o

 # restore old modules

 echo "Restoring old (qla2200.o) qla2300.o and qla2300_conf.o modules"

 if [ "`uname -m`" != "ia64" ] && [ "`uname -m`" != "x86_64" ]
 then
 	if test -f ${MODDIR}/qla2200.orig
 	then
 		mv ${MODDIR}/qla2200.orig ${MODDIR}/qla2200.o
 	fi

 	if test -f /lib/modules/${KERNELVERSION}/kernel/drivers/addon/qla2200/qla2200_conf.orig
        then
                echo "Restoring qla2200_conf.o in /lib/modules/${KERNELVERSION}/kernel/drivers/addon/qla2200"
                mv -f /lib/modules/${KERNELVERSION}/kernel/drivers/addon/qla2200/qla2200_conf.orig /lib/modules/`uname -r`/kernel/d
rivers/addon/qla2200/qla2200_conf.o
        fi
 fi

 if test -f ${MODDIR}/qla2300.orig
 then
 	mv ${MODDIR}/qla2300.orig ${MODDIR}/qla2300.o
 fi

 if test -f ${SCSIDIR}/qla2300_conf.orig
 then
  mv ${SCSIDIR}/qla2300_conf.orig ${SCSIDIR}/qla2300_conf.o
 fi

 if test -f /lib/modules/${KERNELVERSION}/kernel/drivers/addon/qla2200/qla2300_conf.orig
 then
        echo "Restoring qla2300_conf.o in /lib/modules/${KERNELVERSION}/kernel/drivers/addon/qla2200"
        mv -f /lib/modules/${KERNELVERSION}/kernel/drivers/addon/qla2200/qla2300_conf.orig /lib/modules/${KERNELVERSION}/kernel/drivers/addon/qla2200/qla2300_conf.o
 fi

 # run depmod

 echo "Running depmod -a"
 depmod -a

 # remove entries from /etc/modules.conf

 echo "Removing entries for qla2200 and qla2300 from /etc/modules.conf"
 cat /etc/modules.conf | grep -v "alias scsi_hostadapter.* qla2200_conf"| grep -v "alias scsi_hostadapter.* qla2300_conf" | grep -v "post-remove qla2200 rmmod qla2200_conf" | grep -v "post-remove qla2300 rmmod qla2300_conf" | grep -v "options qla2200" | grep -v "options qla2300" | grep -v "alias scsi_hostadapter.* sg"  > /tmp/modules.tmp
 mv -f /etc/modules.conf /etc/modules.conf.old
 mv -f /tmp/modules.tmp /etc/modules.conf

 # remove entries from /etc/sysconfig/kernel if needed

 if [ -a /etc/sysconfig/kernel ]
 then
 	echo "Removing entries for qla2300_conf and sg from /etc/sysconfig/kernel"
 	cat /etc/sysconfig/kernel | sed 's/qla2300_conf//g' | sed 's/sg//g' > /etc/sysconfig/kernel.tmp
 	mv -f /etc/sysconfig/kernel /etc/sysconfig/kernel.old
 	mv -f /etc/sysconfig/kernel.tmp /etc/sysconfig/kernel
 	chmod 644 /etc/sysconfig/kernel
 	chown root:root /etc/sysconfig/kernel
 fi

 # remove /opt/hp/src/hp_qla2x00src

 echo "Removing $SRCDIR"
 cd $SRCDIR

 if [ $? -eq 0 ]
 then
	rm -f *
 	cd ../
 	rmdir $SRCDIR
 fi

 # cleanup

 rm -f /tmp/.hp_pkinstall
 
 echo ""
 echo "Your initrd has not been updated.  You will have to do that manually."
else
 # if this is an upgrade, don't remove anything

 echo -n "" # no-op
fi

exit 0

