/* Copyright (c)  2003-2005 QLogic Corporation
*  QLogic Linux Fibre Channel Driver
*
*This program includes a device driver for Linux - 2.4.x that may be 
*distributed with QLogic hardware specific firmware binary file.  You may modify
*and redistribute the device driver code under the GNU General Public License as
*published by the Free Software Foundation (version 2 or a later version) and/or
*under the following terms, as applicable:
*
*	1. Redistribution of source code must retain the above copyright
*	   notice, this list of conditions and the following disclaimer.
*
*	2. Redistribution in binary form must reproduce the above copyright 
*	   notice, this list of conditions and the following disclaimer in the 
*	   documentation and/or other materials provided with the distribution.
*
*	3. The name of QLogic Corporation may not be used to endorse or promote 
*	   products derived from this software without specific prior written 
*	   permission.
*	
*You may redistribute the hardware specific firmware binary file under the 
*following terms:
*	1. Redistribution of source code (only if applicable), must retain the 
*	   above copyright notice, this list of conditions and the following 
*	   disclaimer.
*	2. Redistribution in binary form must reproduce the above copyright 
*	   notice, this list of conditions and the following disclaimer in 
*	   the documentation and/or other materials provided with the 
*	   distribution.
*	3. The name of QLogic Corporation may not be used to endorse or promote
*	   products derived from this software without specific prior written 
*	   permission.
*
*	REGARDLESS OF WHAT LICENSING MECHANISM IS USED OR APPLICABLE, THIS 
*	PROGRAM IS PROVIDED BY QLOGIC CORPORATION "AS IS'' AND ANY EXPRESS 
*	OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
*	WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
*	ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, 
*	INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
*	(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
*	 SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
*	HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
*	STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING 
*	IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
*	POSSIBILITY OF SUCH DAMAGE.
*
*	USER ACKNOWLEDGES AND AGREES THAT USE OF THIS PROGRAM WILL NOT CREATE 
*	OR GIVE GROUNDS FOR A LICENSE BY IMPLICATION, ESTOPPEL, OR OTHERWISE 
*	IN ANY INTELLECTUAL PROPERTY RIGHTS (PATENT, COPYRIGHT, TRADE SECRET, 
*        MASK WORK, OR OTHER PROPRIETARY RIGHT) EMBODIED IN ANY OTHER QLOGIC 
*	HARDWARE OR SOFTWARE EITHER SOLELY OR IN COMBINATION WITH THIS PROGRAM.
*/

/*
 * This file includes a set of defines that are required to compile the 
 * source code for qla2xxx module
 */

static inline int 
check_device_id(scsi_qla_host_t *ha)
{
	return (ha->device_id == QLA6322_DEVICE_ID ||
	    ha->device_id == QLA2322_DEVICE_ID); 
}

static inline int 
check_all_device_ids(scsi_qla_host_t *ha)
{
	return (ha->device_id == QLA6312_DEVICE_ID ||
	    ha->device_id == QLA6322_DEVICE_ID ||
	    ha->device_id == QLA2312_DEVICE_ID ||
	    ha->device_id == QLA2322_DEVICE_ID);
}

#define qla2x00_is_guadalupe(ha) ((ha->device_id == QLA2322_DEVICE_ID) && \
                              (ha->subsystem_device == 0x0170) && \
                              (ha->subsystem_vendor == 0x1028))

static inline int 
check_24xx_device_ids(scsi_qla_host_t *ha)
{
	return ((ha->device_id & 0xff00) == 0x2400);
}

static inline int 
check_25xx_device_ids(scsi_qla_host_t *ha)
{
	return ((ha->device_id & 0xff00) == 0x2500);
}
static inline void 
set_model_number(scsi_qla_host_t *ha)
{
 	if (ha->device_id == QLA6312_DEVICE_ID ||
	    ha->device_id == QLA6322_DEVICE_ID)
		sprintf(ha->model_number, "QLA63xx");
 	else
		sprintf(ha->model_number, "QLA23xx");
}

static inline uint8_t *host_to_fcp_swap(uint8_t *, uint32_t);

/**
 * host_to_fcp_swap() - 
 * @fcp: 
 * @bsize: 
 *
 * Returns 
 */
static inline uint8_t *
host_to_fcp_swap(uint8_t *fcp, uint32_t bsize)
{
	uint32_t *ifcp = (uint32_t *) fcp;
	uint32_t *ofcp = (uint32_t *) fcp;
	uint32_t iter = bsize >> 2;

	for (; iter ; iter--)
		*ofcp++ = swab32(*ifcp++);

	return (fcp);
}

